\ Partname: ATmega644P
\ hand crafted  EW

\ PORTA
&34 constant PORTA      \ Port A Data Register
&33 constant DDRA       \ Port A Data Direction Register
&32 constant PINA       \ Port A Input Pins
\ PORTB
&37 constant PORTB      \ Port B Data Register
&36 constant DDRB       \ Port B Data Direction Register
&35 constant PINB       \ Port B Input Pins
\ PORTC
&40 constant PORTC      \ Port C Data Register
&39 constant DDRC       \ Port C Data Direction Register
&38 constant PINC       \ Port C Input Pins
\ PORTD
&43 constant PORTD      \ Port D Data Register
&42 constant DDRD       \ Port D Data Direction Register
&41 constant PIND       \ Port D Input Pins

\ TWI, I2C
&189 constant TWAMR     \ TWI (Slave) Address Mask Register
&184 constant TWBR      \ TWI Bit Rate register
&188 constant TWCR      \ TWI Control Register
&185 constant TWSR      \ TWI Status Register
&187 constant TWDR      \ TWI Data register
&186 constant TWAR      \ TWI (Slave) Address register

\ TIMER_COUNTER_0
&72 constant OCR0B      \ Timer/Counter0 Output Compare Register
&71 constant OCR0A      \ Timer/Counter0 Output Compare Register
&70 constant TCNT0      \ Timer/Counter0
&69 constant TCCR0B     \ Timer/Counter Control Register B
&68 constant TCCR0A     \ Timer/Counter  Control Register A
&110 constant TIMSK0    \ Timer/Counter0 Interrupt Mask Register
&53 constant TIFR0      \ Timer/Counter0 Interrupt Flag register

\ TIMER_COUNTER_1
&111 constant TIMSK1    \ Timer/Counter1 Interrupt Mask Register
&54 constant TIFR1      \ Timer/Counter Interrupt Flag register
&128 constant TCCR1A    \ Timer/Counter1 Control Register A
&129 constant TCCR1B    \ Timer/Counter1 Control Register B
&130 constant TCCR1C    \ Timer/Counter1 Control Register C
&132 constant TCNT1     \ Timer/Counter1  Bytes
&136 constant OCR1A     \ Timer/Counter1 Output Compare Register A  Bytes
&138 constant OCR1B     \ Timer/Counter1 Output Compare Register B  Bytes
&134 constant ICR1      \ Timer/Counter1 Input Capture Register  Bytes


\ TIMER_COUNTER_2
&112 constant TIMSK2    \ Timer/Counter Interrupt Mask register
&55 constant TIFR2      \ Timer/Counter Interrupt Flag Register
&176 constant TCCR2A    \ Timer/Counter2 Control Register A
&177 constant TCCR2B    \ Timer/Counter2 Control Register B
&178 constant TCNT2     \ Timer/Counter2
&180 constant OCR2B     \ Timer/Counter2 Output Compare Register B
&179 constant OCR2A     \ Timer/Counter2 Output Compare Register A
&182 constant ASSR      \ Asynchronous Status Register
  $20 constant ASSR_AS2 \ Asynchronous Timer/Counter2


\ Interrupts
&2  constant INT0Addr \ External Interrupt Request 0
&4  constant INT1Addr \ External Interrupt Request 1
&6  constant INT2Addr \ External Interrupt Request 2
&8  constant PCINT0Addr \ Pin Change Interrupt Request 0
&10  constant PCINT1Addr \ Pin Change Interrupt Request 1
&12  constant PCINT2Addr \ Pin Change Interrupt Request 2
&14  constant PCINT3Addr \ Pin Change Interrupt Request 3
&16  constant WDTAddr \ Watchdog Time-out Interrupt
&18  constant TIMER2_COMPAAddr \ Timer/Counter2 Compare Match A
&20  constant TIMER2_COMPBAddr \ Timer/Counter2 Compare Match B
&22  constant TIMER2_OVFAddr \ Timer/Counter2 Overflow
&24  constant TIMER1_CAPTAddr \ Timer/Counter1 Capture Event
&26  constant TIMER1_COMPAAddr \ Timer/Counter1 Compare Match A
&28  constant TIMER1_COMPBAddr \ Timer/Counter1 Compare Match B
&30  constant TIMER1_OVFAddr \ Timer/Counter1 Overflow
&32  constant TIMER0_COMPAAddr \ Timer/Counter0 Compare Match A
&34  constant TIMER0_COMPBAddr \ Timer/Counter0 Compare Match B
&36  constant TIMER0_OVFAddr \ Timer/Counter0 Overflow
&38  constant SPI__STCAddr \ SPI Serial Transfer Complete
&40  constant USART0__RXAddr \ USART0, Rx Complete
&42  constant USART0__UDREAddr \ USART0 Data register Empty
&44  constant USART0__TXAddr \ USART0, Tx Complete
&46  constant ANALOG_COMPAddr \ Analog Comparator
&48  constant ADCAddr \ ADC Conversion Complete
&50  constant EE_READYAddr \ EEPROM Ready
&52  constant TWIAddr \ 2-wire Serial Interface
&54  constant SPM_READYAddr \ Store Program Memory Read
&56  constant USART1_RXAddr \ USART1 RX complete
&58  constant USART1_UDREAddr \ USART1 Data Register Empty
&60  constant USART1_TXAddr \ USART1 TX complete
