\ 2017-03-27 EW   ewlib/clock_tick_v5.0a.fs
\
\ 128 ticks/s
\ Forth ISR, requires AmForth 6.5 or later
\ 
\ words:
\        +ticks2   register and enable interupt
\        -ticks2   disable interupt

\ use phase accumulator to create adjustable seconds
\ requires 2variable 2constant 2@ 2!

\ default: 2^32/2^7 = 2^25 = $2000000 = #33554432
$2000000.  2Evalue    EE.fcontrol \ eeprom backup
           2variable  ct.fcontrol
           2variable  ct.phase

variable ct.ticks2
variable ct.ticks2.follow
#1 constant cycles/tick

: tick.over? ( -- t/f ) ct.ticks2.follow @  ct.ticks2 @  - 0< ;


\ timer 2 overflow ISR
: tick2_isr
  1 ct.ticks2 +!
;

\ enable ticks
\ crystal:   32768 /sec
\ clock src: 32768 /sec
\ overflow:  32768/256 = 128 /sec =^= 7.8125 milli-sec ticks
: +ticks2
  EE.fcontrol ct.fcontrol     2!
  0.          ct.phase        2!
  0           ct.ticks2        !
  0           ct.ticks2.follow !

  [ %00000000                 \ normal mode
  ] literal TCCR2A c!
  [ %00000001                 \ 001 = clock_ts2
  ] literal TCCR2B c! 
  ASSR_AS2 ASSR  c!           \ source: 32 kiHz crystal 
  ['] tick2_isr TIMER2_OVFAddr int! \ register ISR
  TIMSK2 c@ $01 or TIMSK2 c!  \  enable OVF2 interupt
;

\ disable ticks
: -ticks2
  TIMSK2 c@
  [ $01 invert ] literal
  and TIMSK2  c! ( clr Timer 2 )
  $00  ASSR   c!
  $00  TCCR2B c!
  $07  TIFR2  c! \ clear interrupt flags, jibc
;
