\ 2017-05-05 ew ewlib/clocks_v0.1.fs
\
\ create an infrastructure to accomodate more than one
\ set of counters for a clock.
\
\ this attempts to spend RAM space and trade it for
\ simpler code. Try to avoid converting times ...
\
\ RAM array of counters (cells)
\ optional: uptime or epochseconds (double)
\ 0: second
\ 1: minute
\ 2: hour
\ 3: day (offset by 1)
\ 4: month (offset by 1)
\ 5: year
\ 6: pointer to TZ string (flash)

\ base address of currently used clock data
variable _clock
\ total length of data structure (cells)
#8 constant _Nclock
\ named indices into the current clock data
: tick  ( -- addr ) _clock @            ;
: sec   ( -- addr ) _clock @ #1 cells + ;
: min   ( -- addr ) _clock @ #2 cells + ;
: hour  ( -- addr ) _clock @ #3 cells + ;
: day   ( -- addr ) _clock @ #4 cells + ;
: month ( -- addr ) _clock @ #5 cells + ;
: year  ( -- addr ) _clock @ #6 cells + ;
: tz    ( -- addr ) _clock @ #7 cells + ; \ init ?


\ define a clock <name>
\ create
\ - allot counters, save address
\ - store label in flash, save address
\ does>
\ - store counters base address in _clock

: clock: ( <name> s" label" -- )
  dp >r s, r>              \ -- f-addr
  <builds
  here dup ( ram-p )   ,   \ -- f-addr r-addr
  over     ( flash-p ) ,
  _Nclock cells allot
  _clock !                 \ -- f-addr
  tz !                     \ -- 
does>
  dup @i  _clock !
  1+  @i  tz !
;

: .date  ( -- )
  year  @    #4 u0.r  \ [char] - emit
  month @ 1+ #2 u0.r  \ [char] - emit
  day   @ 1+ #2 u0.r
;
: .time  ( -- )
  hour  @    #2 u0.r [char] : emit
  min   @    #2 u0.r [char] : emit
  sec   @    #2 u0.r
;
: .tz ( -- )
  tz    @    icount itype 
;



\ s" UT"   clock: UT
\ s" MEZ"  clock: MEZ
\ s" MESZ" clock: MESZ
\
\ UT   .time space .tz cr
\ MEZ  .time space .tz cr