
\ 2014-10-13  ew  ewlib/epochseconds.fs

\ needs lib/ans94/double/m-star-slash.frt

\ words
\     leapyear?   FIXME: there is an implementation in ewlib/timeup.fs as well
\     __Epoch     1970, constant
\     s>dt ( d:EpochSeconds -- sec min hour day month year )
\     CET CEST timezone offsets in hours (integral) FIXME: change to seconds
\     dt>s ( dst sec min hour day month year -- d:epochsec )
\ internal only
\     365+1 ( year -- 365|366 )
\     years/mod
\     __acc_days  -- accumulated days of year at 1st of each month (0..11)
\     months/mod

\ \ leapyear
\ : leapyear? ( yyyy -- t/f )
\     dup    &4 mod 0=
\     over &100 mod 0<> and
\     swap &400 mod 0=  or
\ ;  
&1970 constant __Epoch
: 365+1 ( year -- 365|366 )
    &365 swap leap_year? if 1+ then
;
: years/mod.short ( T/day -- years T/day' )
    dup &365 u>= if         \ -- T
        _last_epoch @ swap  \ -- year T
        begin
            over 365+1
            -
            swap 1+ swap    \ -- T-365/6 year+1
            over 365+1      \ -- year' T' 365
            over swap       \ -- year' T' T' 365
        u>= 0= until
    else
        _last_epoch @ swap
    then
    
;
: years/mod ( T/day -- years T/day' )
    dup &365 u>= if         \ -- T
        __Epoch swap        \ -- year T
        begin
            over 365+1
            -
            swap 1+ swap    \ -- T-365/6 year+1
            over 365+1      \ -- year' T' 365
            over swap       \ -- year' T' T' 365
        u>= 0= until
    else
        __Epoch swap
    then
;
create __acc_days 0 , &31 , &59 , &90 , &120 , &151 , &181 , &212 , &243 , &273 , &304 , &334 , &365 ,
: months/mod ( year T/day -- year month T/day' )
    dup 0= if
        drop 1 1
    else
        &12 swap            \ -- year month T
        begin
            over __acc_days + @i
                            \ -- year month T acc_days[month]
            \ correct acc_days for leap year and months > 1 (January)
            3 pick leap_year? 3 pick 1 > and if 1+ then
            over over swap   \ -- year month T acc_days[month] acc_days[month] T
            u>
        while               \ -- year month T
                drop swap 1- swap
                            \ -- year month-1 T
        repeat              \ -- year month' T acc_days[month']
        -                   \ -- year month' T-acc_days[month']
        swap 1+
        swap 1+
    then
;
    
: s>dt.short  ( d:EpochSeconds -- sec min hour day month year )
    _last_esec 2@ d-
    &60 ud/mod          \ -- sec T/min
    &60 ud/mod          \ -- sec min T/hour
    &24 ud/mod          \ -- sec min hour T/day
    d>s
    years/mod.short     \ -- sec min hour year T/day
    months/mod          \ -- sec min hour year month day
    swap                \ -- sec min hour year day month
    rot                 \ -- sec min hour day month year
;

: s>dt  ( d:EpochSeconds -- sec min hour day month year )
    &60 ud/mod          \ -- sec T/min
    &60 ud/mod          \ -- sec min T/hour
    &24 ud/mod          \ -- sec min hour T/day
    d>s
    years/mod           \ -- sec min hour year T/day
    months/mod          \ -- sec min hour year month day
    swap                \ -- sec min hour year day month
    rot                 \ -- sec min hour day month year
;

: ut>s.short ( sec min hour day month year -- T/sec )
    \ add start value T=0
    0 over              \ -- sec min hour day month year T=0 year
    _last_epoch @       \ -- sec min hour day month year T year Epoch
    ?do
        i 365+1 +
    loop                \ -- sec min hour day month year T/days
    2 pick 1-           \ -- sec min hour day month year T/days month-1
    __acc_days + @i     \ -- sec min hour day month year T/days acc_days[month]
    +                   \ -- sec min hour day month year T/days
    swap                \ -- sec min hour day month T/days year
    leap_year? rot 2 > and if 1+ then
    \                   \ -- sec min hour day T/days
    swap 1- +           \ -- sec min hour T/days
    s>d
    24 1 m*/ rot s>d d+ \ -- sec min T/hours
    60 1 m*/ rot s>d d+ \ -- sec T/minutes
    60 1 m*/ rot s>d d+ \ -- T/sec
    _last_esec 2@ d+    \ -- T/sec
;

: ut>s ( sec min hour day month year -- T/sec )
    \ add start value T=0
    0 over              \ -- sec min hour day month year T=0 year
    __Epoch             \ -- sec min hour day month year T year Epoch
    ?do
        i 365+1 +
    loop                \ -- sec min hour day month year T/days
    2 pick 1-           \ -- sec min hour day month year T/days month-1
    __acc_days + @i     \ -- sec min hour day month year T/days acc_days[month]
    +                   \ -- sec min hour day month year T/days
    swap                \ -- sec min hour day month T/days year
    leap_year? rot 2 > and if 1+ then
    \                   \ -- sec min hour day T/days
    swap 1- +           \ -- sec min hour T/days
    s>d
    24 1 m*/ rot s>d d+ \ -- sec min T/hours
    60 1 m*/ rot s>d d+ \ -- sec T/minutes
    60 1 m*/ rot s>d d+ \ -- T/sec
;

0 constant CET
1 constant CEST
: dt>s ( dst sec min hour day month year -- d:epochsec )

  ut>s                     \ -- dst T/sec
  3600. d-                 \ -- dst T/sec timezone corrected
  rot 0<> if 3600. d- then \ -- T/sec daylight savings time corrected
;



\ fin
