\ 2015-09-30 EW   hd44780-4bit.fs
\ removed 1ms calls

\ needs bitnames.frt
\ needs ans.frt (ms)
\ needs $(MCU).fs (sfr und pin names)

\ requires:
\     _hd44780-en  pin definition
\     _hd44780-rs
\     _hd44780-rw
\     hd44780-port
\     hd44780-ddr
\     hd44780-data-mask
\

: hd44780-data-pins-input  ( -- ) hd44780-ddr c@  hd44780-data-mask invert and  hd44780-ddr c! ;
: hd44780-data-pins-output ( -- ) hd44780-ddr c@  hd44780-data-mask or          hd44780-ddr c! ;
: hd44780-pulse-en         ( -- ) _hd44780-en high  _hd44780-en low ;
: hd44780-data-mode        ( -- ) _hd44780-rs high ;
: hd44780-command-mode     ( -- ) _hd44780-rs low  ;
: hd44780-read-mode        ( -- ) hd44780-data-pins-input  _hd44780-rw high ;
: hd44780-write-mode       ( -- ) hd44780-data-pins-output _hd44780-rw low  ;
: hd44780-read-busy        ( -- t/f )
  hd44780-data-pins-input
  hd44780-read-mode
  hd44780-command-mode
  hd44780-pulse-en hd44780-port c@  $80 and \ t/f
  hd44780-pulse-en hd44780-port c@ drop
;
: hd44780-write-nibble ( x -- )
  hd44780-write-mode
  4 lshift
  hd44780-port c@ hd44780-data-mask invert and
  or
  hd44780-port c!
  hd44780-pulse-en
;

: hd44780-write-byte ( x -- )

  dup 4 rshift $0F and hd44780-write-nibble
               $0F and hd44780-write-nibble
;
: hd44780-4bit-init
    _hd44780-rs pin_output
    _hd44780-rw pin_output
    _hd44780-en pin_output

    hd44780-command-mode
                              #15 ms
    $03 hd44780-write-nibble   #5 ms
    $03 hd44780-write-nibble     1ms
    $03 hd44780-write-nibble     1ms
    $02 hd44780-write-nibble     1ms  \ we reach 4-bit mode here

    $28 hd44780-write-byte       1ms  \ function set: 4bit, 2 lines, 5x7 font
    $08 hd44780-write-byte       1ms  \ display off, cursor off
    $01 hd44780-write-byte       1ms  \ clear display
    $06 hd44780-write-byte       1ms  \ cursor autoincrement
    $0e hd44780-write-byte       1ms  \ display on, cursor on, blinking off
    $80 hd44780-write-byte       1ms  \ cursor position
;

: hd44780-emit ( c -- )
    hd44780-data-mode
    ( c ) hd44780-write-byte
;

: hd44780-page ( -- )
  hd44780-command-mode
  $01 hd44780-write-byte \ clear display
  $03 hd44780-write-byte \ cursor home
;
