\ 2017-05-10 shiftregister.fs
\
\ needs pin definitions
\     PORTD 2 portpin: sr_latch
\     PORTD 3 portpin: sr_clock
\     PORTD 4 portpin: sr_data
\ words:
\     +sr ( -- )     \ enable shift register
\     emit.sr ( n -- )     \ transfer 1 Byte
\     type.sr ( xn-1 .. x0 n -- )  \ n Bytes

: +sr  
  sr_latch pin_output  sr_latch high
  sr_clock pin_output  sr_clock low
  sr_data  pin_output  sr_data  high
;

: bit>sr ( bit -- )
  if sr_data high else sr_data low then
  sr_clock high  sr_clock low
;

: get.bit ( byte pos -- bit )
  1 swap lshift    \ -- byte bitmask
  and              \ -- bit
;

\ clock one byte out, MSB first!
: byte>sr ( byte -- )
  8 0 do
    dup 7 i -  \ 7 6 5 ... 0: MSB first!
    get.bit
    bit>sr
  loop
  drop
;

: >sr
  byte>sr
  sr_latch low sr_latch high
;

