\ 2017-05-06 EW  timeup_3.0.fs
\ change to use different (clock) data arrays

\ variables
\     tu.counts -- fields available as:
\     tick sec min hour day month year
\ words:
\     timeup.init
\     timeup
\     lastday_of_month ( year month -- last_day )
\     tu.get  ( -- S M H d m Y )
\     tu.set  ( Y m d H M S -- )
\     tu.show ( -- )

include ewlib/leap_year_q.fs
\ include ewlib/clocks_v0.1.fs
    
variable tu.flags

\ variable tu.counts     #7 cells allot
\ tu.counts            constant tick
\ tu.counts #1 cells + constant sec
\ tu.counts #2 cells + constant min
\ tu.counts #3 cells + constant hour
\ tu.counts #4 cells + constant day
\ tu.counts #5 cells + constant month
\ tu.counts #6 cells + constant year

\ in main.fs
\ s" UT" clock: UT

variable tu.limits     #6       allot
: tu.max.sec   tu.limits  1+  ;
: tu.max.min   tu.limits #2 + ;
: tu.max.hour  tu.limits #3 + ;
: tu.max.day   tu.limits #4 + ;
: tu.max.month tu.limits #5 + ;

create tu.lastday_of_month
   #31 , #28 , #31 , #30 , #31 , #30 ,
   #31 , #31 , #30 , #31 , #30 , #31 ,

: lastday_of_month ( year month -- last_day )
  dup 1-                \ array starts at 0
  tu.lastday_of_month + @i
  swap #2 = if          \ if month == 2
    swap leap_year? if  \   if leap_year
      1+                \     month += 1
    then
  else                  \ else
    swap drop           \   remove year
  then
;

: timeup.init
  0      tu.flags !
  \ tu.counts #8 erase
  #60  tu.max.sec   c!
  #60  tu.max.min   c!
  #24  tu.max.hour  c!
  #31  tu.max.day   c! \ fixme: may be wrong later!
  #12  tu.max.month c!
;


\ requires _clock to be set correctly!
\ is called at "second over"
\ original loop replaced by if-else chain,
\ which is short-cutting as well
: timeup ( -- )
  1 sec +!                         \ sec++
  $02 tu.flags fset                \ secflag++

  sec @ 1+  tu.max.sec c@ > if
    \ min.over
    tu.max.sec c@ negate  sec +!   \ sec -= max.sec
    1 min +!                       \ min++
    $04 tu.flags fset              \ minflag++

    min @ 1+  tu.max.min c@ > if
      \ hour.over
      0 min !
      1 hour +!
      $08 tu.flags fset

      hour @ 1+  tu.max.hour c@ > if
        \ day.over
        0 hour !
        1 day +!
        $10 tu.flags fset
        \ fixme: day of year++
        \ fixme: day of week++ % 7

        day @ 1+  tu.max.day c@ > if
          \ month.over
          0 day !
          1 month +!
          $20 tu.flags fset

          month @ 1+  tu.max.month c@ > if
            \ year.over
            0 month !
            1 year +!
            $40 tu.flags fset
            \ fixme: reset day of year
          then
        then
      then
    then
  then
;

\ update lastday_of_month in tu.limits
\ once current date is known
: tu.upd.limits ( Y m -- )
\  ( Y m ) lastday_of_month  tu.limits #4 + c!
  ( Y m ) lastday_of_month  tu.max.day  c!
;
: tu.set ( Y m d H M S -- )
  sec ! min ! hour !
  1- day !
  over over 1- month ! year !
  ( Y m ) tu.upd.limits
;
: tu.get ( -- S M H d m Y )
  sec @ min @ hour @
  day @ 1+ month @ 1+ year @
;
: tu.show ( -- )
  tu.get
  #4 u0.r  #2 u0.r  #2 u0.r  [char] -  emit
  #2 u0.r  #2 u0.r  #2 u0.r  space .tz
;
